using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using Exferia_EntityFramework;
using Exferia_General._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.Objects.SqlClient;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class GEN_Terminales_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_GEN_Terminales_Listado_Modelo> g_lst_INTERNO_GEN_Terminales_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta...........................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Terminales).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...................................................

                if ((g_lst_INTERNO_GEN_Terminales_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Terminales_Listado_Modelo.Count() > 0))
                {
                    lst_MYT = g_lst_INTERNO_GEN_Terminales_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MYT;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta..................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Terminales).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //..........................................................

                if ((g_lst_INTERNO_GEN_Terminales_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Terminales_Listado_Modelo.Count() > 0))
                {
                    dnm_MYT = g_lst_INTERNO_GEN_Terminales_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                int int_Tipo_Actual = -1;

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Tipo
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO == nameof(GEN_Terminales.tipo))
                        {
                            int_Tipo_Actual = (int)mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR_AUXILIAR;
                        }
                    }
                }

                string str_SQL =
                   " SELECT " +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.id) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.codigo) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.codigo) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.descripcion) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.descripcion) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.tipo) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.tipo) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.idEmpresa) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.idEmpresa) + 
               " FROM " + nameof(GEN_Terminales) +
               " WHERE " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.fechaBorrado) + " IS null AND " +
                        //tipo
                        (int_Tipo_Actual > -1 ? (nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.tipo) + "=@tipo AND ") : "1 = 1 AND ") +
                        (_lng_id > -1 ? (nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + "=@id") : "1 = 1");

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                if (int_Tipo_Actual > -1)
                {
                    lst_Parametros.Add(new SqlParameter("@tipo", int_Tipo_Actual));
                }
                if (_lng_id > -1)
                {
                    lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                }

                //Rellenar el Modelo
                g_lst_INTERNO_GEN_Terminales_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Terminales_Listado_Modelo>(str_SQL, lst_Parametros.ToArray()).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_GEN_Terminales_Listado_Modelo g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3 = null;


        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta...........................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Terminales).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...................................................................

                if (g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Terminales).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //....................

                if (g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }


        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                int int_Tipo_Actual = -1;

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //Tipo
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO == nameof(GEN_Terminales.tipo))
                        {
                            int_Tipo_Actual = (int)mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR_AUXILIAR;
                        }
                    }
                }


                string str_SQL =
                   " SELECT distinct " +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.id) + " = " + nameof(GEN_Terminales.id) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.codigo) + " = " + nameof(GEN_Terminales.codigo) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.descripcion) + " = " + nameof(GEN_Terminales.descripcion) +
               " FROM " + nameof(GEN_Terminales) +
               " WHERE " + nameof(GEN_Terminales.fechaBorrado) + " IS null AND " +
                        //tipo
                        (int_Tipo_Actual > -1 ? (nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.tipo) + "=@tipo AND ") : "1 = 1 AND ") +
                       (
                        (_lng_id > -1)
                          ? (nameof(GEN_Terminales.id) + " = " + _lng_id)
                          : (
                               //Filtrar por Codigo
                               (_str_CampoBusqueda.Equals(nameof(GEN_Terminales.codigo)))
                                   ? (nameof(GEN_Terminales.codigo) + "=@Filtro")
                                   //Filtrar por Descripcion
                                   : (nameof(GEN_Terminales.descripcion) + "=@Filtro")
                           )
                       );

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                if (int_Tipo_Actual > -1)
                {
                    lst_Parametros.Add(new SqlParameter("@tipo", int_Tipo_Actual));
                }
                if (_lng_id <= 0)
                {
                    lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                }

                //Rellenar el Modelo
                g_mdl_INTERNO_GEN_Terminales_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Terminales_Listado_Modelo>(str_SQL, lst_Parametros.ToArray()).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.codigo) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.descripcion) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.tipo) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.fechaBorrado) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.codigoValidacion) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.codigoValidacionUtilizado) + " , " +
                              nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.idEmpresa) +
                        " FROM " + nameof(GEN_Terminales) +
                        " WHERE  " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.fechaBorrado) + " IS null AND " +
                                     nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<GEN_Terminales>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //GEN_Terminales_Opciones ##########################################################################################
                    ThreadStart obj_ThreadStart_TERMINALESOPCIONES = new ThreadStart(Obtener_TerminalesOpciones_Modelo_Obtener);
                    Thread obj_Thread_TERMINALESOPCIONES = new Thread(obj_ThreadStart_TERMINALESOPCIONES);
                    obj_Thread_TERMINALESOPCIONES.Start();

                    //GEN_Terminales_ValidacionesHistorico ##########################################################################################
                    ThreadStart obj_ThreadStart_VALIDACIONESHISTORICO = new ThreadStart(Obtener_ValidacionesHistorico_Modelo_Obtener);
                    Thread obj_Thread_VALIDACIONESHISTORICO = new Thread(obj_ThreadStart_VALIDACIONESHISTORICO);
                    obj_Thread_VALIDACIONESHISTORICO.Start();

                    //GEN_Terminales_Delegaciones_Configuracion ##########################################################################################
                    ThreadStart obj_ThreadStart_TERMINALESDELEGACIONESCONFIGURACION = new ThreadStart(Obtener_TerminalesDelegacionesConfiguracion_Modelo_Obtener);
                    Thread obj_Thread_TERMINALESDELEGACIONESCONFIGURACION = new Thread(obj_ThreadStart_TERMINALESDELEGACIONESCONFIGURACION);
                    obj_Thread_TERMINALESDELEGACIONESCONFIGURACION.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_TerminalesOpciones_Modelo_Obtener()
        {
            try
            {
                GEN_Terminales_Opciones_Datos obj_GEN_Terminales_Opciones_Datos = new GEN_Terminales_Opciones_Datos();
                g_dnm_Modelo_Obtener.GEN_Terminales_Opciones = obj_GEN_Terminales_Opciones_Datos.Obtener_ModeloListado_Por_IdTerminal(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_ValidacionesHistorico_Modelo_Obtener()
        {
            try
            {
                GEN_Terminales_ValidacionesHistorico_Datos obj_GEN_Terminales_ValidacionesHistorico_Datos = new GEN_Terminales_ValidacionesHistorico_Datos();
                g_dnm_Modelo_Obtener.GEN_Terminales_ValidacionesHistorico = obj_GEN_Terminales_ValidacionesHistorico_Datos.Obtener_ModeloListado_Por_IdTerminal(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_TerminalesDelegacionesConfiguracion_Modelo_Obtener()
        {
            try
            {
                GEN_Terminales_Delegaciones_Configuracion_Datos obj_GEN_Terminales_Delegaciones_Configuracion_Datos = new GEN_Terminales_Delegaciones_Configuracion_Datos();
                g_dnm_Modelo_Obtener.GEN_Terminales_Delegaciones_Configuracion = obj_GEN_Terminales_Delegaciones_Configuracion_Datos.Obtener_ModeloListado_Por_IdTerminal(g_dnm_Modelo_Obtener.id,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region Para Listado
        private List<INTERNO_GEN_Terminales_Listado_Modelo> g_lst_INTERNO_GEN_Terminales_Listado_Modelo_PARALISTADO = null;

        public List<INTERNO_GEN_Terminales_Listado_Modelo> Obtener_Registros_Para_Listado()
        {
            try
            {
                string str_SQL = Obtener_Consulta_Para_Listado() +
                                    " WHERE " +
                                        nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.fechaBorrado) + " is null  ";

                Ejecutar_Consulta_Modelo_Listado_PARALISTADO(str_SQL,
                                                           new object[] { });
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_Registros_Para_Listado), true);
            }

            return g_lst_INTERNO_GEN_Terminales_Listado_Modelo_PARALISTADO;
        }
        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado_PARALISTADO(string _str_SQL,
                                                                 object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_lst_INTERNO_GEN_Terminales_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Terminales_Listado_Modelo>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado_PARALISTADO), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        private string Obtener_Consulta_Para_Listado()
        {
            return
                   " SELECT " +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.id) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.codigo) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.codigo) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.descripcion) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.descripcion) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.tipo) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.tipo) + "," +
                        nameof(INTERNO_GEN_Terminales_Listado_Modelo.idEmpresa) + " = " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.idEmpresa) +
               " FROM " + nameof(GEN_Terminales);
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private GEN_Terminales g_mdl_GEN_Terminales = null;

        public GEN_Terminales Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_GEN_Terminales;
        }
        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_GEN_Terminales = obj_Exferia_Entities.Database.SqlQuery<GEN_Terminales>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion

        #region Modelo Listado
        private List<GEN_Terminales> g_lst_GEN_Terminales = null;

        public List<GEN_Terminales> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(GEN_Terminales),
                                                                                             nameof(GEN_Terminales.id),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_GEN_Terminales;
        }

        public List<GEN_Terminales> Obtener_ModeloListado()
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(GEN_Terminales) + "." + nameof(GEN_Terminales.fechaBorrado) + " IS null ";

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 new object[] { });
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Obtener_ModeloListado), true);
            }

            return g_lst_GEN_Terminales;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_GEN_Terminales = obj_Exferia_Entities.Database.SqlQuery<GEN_Terminales>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(GEN_Terminales.id) + " , " +
                    nameof(GEN_Terminales.codigo) + " , " +
                    nameof(GEN_Terminales.descripcion) + " , " +
                    nameof(GEN_Terminales.tipo) + " , " +
                    nameof(GEN_Terminales.fechaBorrado) + " , " +
                    nameof(GEN_Terminales.codigoValidacion) + " , " +
                    nameof(GEN_Terminales.codigoValidacionUtilizado) +  " , " +
                    nameof(GEN_Terminales.idEmpresa) +
                " FROM " + nameof(GEN_Terminales);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GEN_Terminales mdl_GEN_Terminales_AGrabar = (GEN_Terminales)_mdl_obj;
                GEN_Terminales mdl_GEN_Terminales_DatosViejos = new GEN_Terminales();

                // Ver si existe ######################################################################
                GEN_Terminales mdl_GEN_Terminales_Final = Obtener_Modelo_Por_Id(mdl_GEN_Terminales_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_GEN_Terminales_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Terminales_Final, mdl_GEN_Terminales_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Terminales_AGrabar, mdl_GEN_Terminales_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_Terminales) +
                                           " SET " +
                                               nameof(GEN_Terminales.codigo) + "=@codigo," +
                                               nameof(GEN_Terminales.descripcion) + "=@descripcion," +
                                               nameof(GEN_Terminales.tipo) + "=@tipo," +
                                               nameof(GEN_Terminales.fechaBorrado) + "=@fechaBorrado, " +
                                               nameof(GEN_Terminales.codigoValidacion) + "=@codigoValidacion, " +
                                               nameof(GEN_Terminales.codigoValidacionUtilizado) + "=@codigoValidacionUtilizado, " +
                                               nameof(GEN_Terminales.idEmpresa) + "=@idEmpresa " +
                                           " WHERE " +
                                               nameof(GEN_Terminales.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                          new SqlParameter("@codigo",  mdl_GEN_Terminales_Final.codigo),
                          new SqlParameter("@descripcion",  mdl_GEN_Terminales_Final.descripcion),
                          new SqlParameter("@tipo",  mdl_GEN_Terminales_Final.tipo),
                          mdl_GEN_Terminales_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_Terminales_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                          mdl_GEN_Terminales_Final.codigoValidacion!=null
                            ?   new SqlParameter("@codigoValidacion", mdl_GEN_Terminales_Final.codigoValidacion)
                            :   new SqlParameter("@codigoValidacion",  DBNull.Value),
                          mdl_GEN_Terminales_Final.codigoValidacionUtilizado!=null
                            ?   new SqlParameter("@codigoValidacionUtilizado", mdl_GEN_Terminales_Final.codigoValidacionUtilizado.Value)
                            :   new SqlParameter("@codigoValidacionUtilizado",  DBNull.Value),
                          mdl_GEN_Terminales_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_GEN_Terminales_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                         new SqlParameter("@id",  mdl_GEN_Terminales_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_GEN_Terminales_Final.id;
                }
                //INSERT
                else
                {
                    mdl_GEN_Terminales_Final = new GEN_Terminales();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Terminales_AGrabar, mdl_GEN_Terminales_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GEN_Terminales) +
                                              " (" +
                                                      nameof(GEN_Terminales.codigo) + "," +
                                                      nameof(GEN_Terminales.descripcion) + "," +
                                                      nameof(GEN_Terminales.tipo) + "," +
                                                      nameof(GEN_Terminales.fechaBorrado) + "," +
                                                      nameof(GEN_Terminales.codigoValidacion) + "," +
                                                      nameof(GEN_Terminales.codigoValidacionUtilizado) + "," +
                                                      nameof(GEN_Terminales.idEmpresa) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(GEN_Terminales.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@codigo," +
                                                  "@descripcion," +
                                                  "@tipo," +
                                                  "@fechaBorrado," +
                                                  "@codigoValidacion," +
                                                  "@codigoValidacionUtilizado, " +
                                                  "@idEmpresa " +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_GEN_Terminales_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_GEN_Terminales_Final.descripcion),
                        new SqlParameter("@tipo",  mdl_GEN_Terminales_Final.tipo),
                        mdl_GEN_Terminales_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_Terminales_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_GEN_Terminales_Final.codigoValidacion!=null
                            ?   new SqlParameter("@codigoValidacion", mdl_GEN_Terminales_Final.codigoValidacion)
                            :   new SqlParameter("@codigoValidacion",  DBNull.Value),
                          mdl_GEN_Terminales_Final.codigoValidacionUtilizado!=null
                            ?   new SqlParameter("@codigoValidacionUtilizado", mdl_GEN_Terminales_Final.codigoValidacionUtilizado.Value)
                            :   new SqlParameter("@codigoValidacionUtilizado",  DBNull.Value),
                          mdl_GEN_Terminales_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_GEN_Terminales_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Terminales), mdl_GEN_Terminales_DatosViejos, mdl_GEN_Terminales_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_CodigoValidacion(long _lng_idTerminal, bool _bol_CodigoValidacionUtilizado, string _str_CodigoValidacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_Update = " UPDATE " + nameof(GEN_Terminales) +
                                        " set " + nameof(GEN_Terminales.codigoValidacion) + "='" + _str_CodigoValidacion + "'," +
                                                  nameof(GEN_Terminales.codigoValidacionUtilizado) + "='" + _bol_CodigoValidacionUtilizado + "' " +
                                    " WHERE " + nameof(GEN_Terminales.id) + "=" + _lng_idTerminal;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Actualizar_CodigoValidacion), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GEN_Terminales mdl_GEN_Terminales_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_GEN_Terminales_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_Terminales) +
                                                " SET " +
                                                nameof(GEN_Terminales.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(GEN_Terminales.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Terminales), null, mdl_GEN_Terminales_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver también el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Terminales_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}